MCP Reference: sheetsmcp.googleapis.com

This is an MCP server which provides tools to interact with Google Sheets.

A Model Context Protocol (MCP) server acts as a proxy between an external service that provides context, data, or capabilities to a Large Language Model (LLM) or AI application. MCP servers connect AI applications to external systems such as databases and web services, translating their responses into a format that the AI application can understand.

MCP Tools

An MCP tool is a function or executable capability that an MCP server exposes to a LLM or AI application to perform an action in the real world.

Tools

The sheetsmcp.googleapis.com MCP server has the following tools:

MCP Tools
get_values Returns a range of values from a spreadsheet. Corresponds to spreadsheets.values.get in the REST API: https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/get
get_spreadsheet Returns the spreadsheet content for the given spreadsheet. Returns titles, sheet names, grid properties, and other metadata for the given spreadsheet ID. Also returns full grid data if requested. Corresponds to spreadsheets.get in the REST API: https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets/get
update_spreadsheet

Applies one or more updates to the spreadsheet.

Corresponds to spreadsheets.batchUpdate in the REST API: https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets/batchUpdate

The list of possible updates is:

  • updateSpreadsheetProperties: Updates the spreadsheet's properties.
  • updateSheetProperties: Updates a sheet's properties.
  • updateDimensionProperties: Updates dimensions' properties.
  • updateNamedRange: Updates a named range.
  • repeatCell: Repeats a single cell across a range.
  • addNamedRange: Adds a named range.
  • deleteNamedRange: Deletes a named range.
  • addSheet: Adds a sheet.
  • deleteSheet: Deletes a sheet.
  • autoFill: Automatically fills in more data based on existing data.
  • cutPaste: Cuts data from one area and pastes it to another.
  • copyPaste: Copies data from one area and pastes it to another.
  • mergeCells: Merges cells together.
  • unmergeCells: Unmerges merged cells.
  • updateBorders: Updates the borders in a range of cells.
  • updateCells: Updates many cells at once.
  • addFilterView: Adds a filter view.
  • appendCells: Appends cells after the last row with data in a sheet.
  • clearBasicFilter: Clears the basic filter on a sheet.
  • deleteDimension: Deletes rows or columns in a sheet.
  • deleteEmbeddedObject: Deletes an embedded object (e.g, chart, image) in a sheet.
  • deleteFilterView: Deletes a filter view from a sheet.
  • duplicateFilterView: Duplicates a filter view.
  • duplicateSheet: Duplicates a sheet.
  • findReplace: Finds and replaces occurrences of some text with other text.
  • insertDimension: Inserts new rows or columns in a sheet.
  • insertRange: Inserts new cells in a sheet, shifting the existing cells.
  • moveDimension: Moves rows or columns to another location in a sheet.
  • updateEmbeddedObjectPosition: Updates an embedded object's (e.g. chart, image) position.
  • pasteData: Pastes data (HTML or delimited) into a sheet.
  • textToColumns: Converts a column of text into many columns of text.
  • updateFilterView: Updates the properties of a filter view.
  • deleteRange: Deletes a range of cells from a sheet, shifting the remaining cells.
  • appendDimension: Appends dimensions to the end of a sheet.
  • addConditionalFormatRule: Adds a new conditional format rule.
  • updateConditionalFormatRule: Updates an existing conditional format rule.
  • deleteConditionalFormatRule: Deletes an existing conditional format rule.
  • sortRange: Sorts data in a range.
  • setDataValidation: Sets data validation for one or more cells.
  • setBasicFilter: Sets the basic filter on a sheet.
  • addProtectedRange: Adds a protected range.
  • updateProtectedRange: Updates a protected range.
  • deleteProtectedRange: Deletes a protected range.
  • autoResizeDimensions: Automatically resizes one or more dimensions based on the contents of the cells in that dimension.
  • addChart: Adds a chart.
  • updateChartSpec: Updates a chart's specifications.
  • updateBanding: Updates a banded range
  • addBanding: Adds a new banded range
  • deleteBanding: Removes a banded range
  • createDeveloperMetadata: Creates new developer metadata
  • updateDeveloperMetadata: Updates an existing developer metadata entry
  • deleteDeveloperMetadata: Deletes developer metadata
  • randomizeRange: Randomizes the order of the rows in a range.
  • addDimensionGroup: Creates a group over the specified range.
  • deleteDimensionGroup: Deletes a group over the specified range.
  • updateDimensionGroup: Updates the state of the specified group.
  • trimWhitespace: Trims cells of whitespace (such as spaces, tabs, or new lines).
  • deleteDuplicates: Removes rows containing duplicate values in specified columns of a cell range.
  • updateEmbeddedObjectBorder: Updates an embedded object's border.
  • addSlicer: Adds a slicer.
  • updateSlicerSpec: Updates a slicer's specifications.
  • addDataSource: Adds a data source.
  • updateDataSource: Updates a data source.
  • deleteDataSource: Deletes a data source.
  • refreshDataSource: Refreshes one or multiple data sources and associated dbobjects.
  • cancelDataSourceRefresh: Cancels refreshes of one or multiple data sources and associated dbobjects.
  • addTable: Adds a table.
  • updateTable: Updates a table.
  • deleteTable: A request for deleting a table.
update_values Sets values in a range of a spreadsheet. Corresponds to spreadsheets.values.update in the REST API: https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/update
update_formulas Sets formulas in a range of a spreadsheet. Corresponds to spreadsheets.values.update in the REST API: https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/update
insert_dimension Inserts rows or columns in a sheet at a particular index. Corresponds to an InsertDimensionRequest in the spreadsheets.batchUpdate REST API: https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets/request

Get MCP tool specifications

To get the MCP tool specifications for all tools in an MCP server, use the tools/list method. The following example demonstrates how to use curl to list all tools and their specifications currently available within the MCP server.

Curl Request
curl --location 'https://sheetsmcp.googleapis.com/mcp' \
--header 'content-type: application/json' \
--header 'accept: application/json, text/event-stream' \
--data '{
    "method": "tools/list",
    "jsonrpc": "2.0",
    "id": 1
}'